diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/RangeIntegerNodeComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/RangeIntegerNodeComponent.java
new file mode 100644
index 000000000..14fe22bc3
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/RangeIntegerNodeComponent.java
@@ -0,0 +1,220 @@
+package net.minecraft.client.gui.worldsettings.settingnode;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import net.minecraft.core.world.settings.impl.RangeIntegerSettingNode;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class RangeIntegerNodeComponent extends ValueNodeComponent<@NotNull Integer> {
+    private final @NotNull IntegerSliderElement slider;
+    private final boolean applyOnRelease = true;
+
+    public RangeIntegerNodeComponent(final @NotNull RangeIntegerSettingNode valueNode, final int nestLevel) {
+        super(valueNode, nestLevel);
+
+        this.slider = new IntegerSliderElement(0, 0, 0, 150, 20);
+    }
+
+    @Override
+    public @NotNull RangeIntegerSettingNode getNode() {
+        return (RangeIntegerSettingNode) super.getNode();
+    }
+
+    @Override
+    public void reset() {
+        super.reset();
+        this.onChange();
+    }
+
+    @Override
+    public void onUpdate(final @NotNull Dimension dimension, final @NotNull WorldConfiguration worldConfiguration) {
+        super.onUpdate(dimension, worldConfiguration);
+        this.onChange();
+    }
+
+    @Override
+    protected boolean buttonClicked(final int mouseButton, final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+        final @Nullable Dimension dimension = this.getDimension();
+        final @Nullable WorldConfiguration worldConfiguration = this.getWorldConfiguration();
+        assert dimension != null && worldConfiguration != null;
+
+        this.slider.mouseClicked(MC, this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
+        if (!this.applyOnRelease) {
+            worldConfiguration.getDimensionSettings(dimension).setNodeValue(this.getNode(), this.slider.sliderValue);
+            this.onChange();
+        } else {
+            this.updateText();
+        }
+
+        return true;
+    }
+
+    @Override
+    protected void buttonDragged(final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+        final @Nullable Dimension dimension = this.getDimension();
+        final @Nullable WorldConfiguration worldConfiguration = this.getWorldConfiguration();
+        assert dimension != null && worldConfiguration != null;
+
+        if (!this.applyOnRelease) {
+            worldConfiguration.getDimensionSettings(dimension).setNodeValue(this.getNode(), this.slider.sliderValue);
+            this.onChange();
+        } else {
+            this.updateText();
+        }
+    }
+
+    @Override
+    protected void buttonReleased(final int mouseButton, final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+        final @Nullable Dimension dimension = this.getDimension();
+        final @Nullable WorldConfiguration worldConfiguration = this.getWorldConfiguration();
+        assert dimension != null && worldConfiguration != null;
+
+        this.slider.mouseReleased(this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
+        worldConfiguration.getDimensionSettings(dimension).setNodeValue(this.getNode(), this.slider.sliderValue);
+        this.onChange();
+    }
+
+    @Override
+    protected void renderButtonInner(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
+        this.slider.xPosition = x + relativeButtonX;
+        this.slider.yPosition = y + relativeButtonY;
+        this.slider.width = buttonWidth;
+        this.slider.height = buttonHeight;
+
+        this.slider.drawButton(MC, x + relativeMouseX, y + relativeMouseY);
+    }
+
+    private void updateText() {
+        this.slider.displayString = this.getNode().getValueText(this.slider.sliderValue).toString();
+    }
+
+    private void onChange() {
+        final @Nullable Dimension dimension = this.getDimension();
+        final @Nullable WorldConfiguration worldConfiguration = this.getWorldConfiguration();
+        assert dimension != null && worldConfiguration != null;
+
+        this.slider.sliderValue = this.getValue();
+        this.slider.min = this.getNode().getMinimumValue(dimension, worldConfiguration);
+        this.slider.max = this.getNode().getMaximumValue(dimension, worldConfiguration);
+        this.updateText();
+    }
+
+    private static class IntegerSliderElement extends ButtonElement {
+        public int sliderValue;
+        public boolean dragging;
+        public boolean renderText = true;
+        private int min;
+        private int max;
+
+        public IconCoordinate backgroundTexture;
+
+        public IntegerSliderElement(final int id, final int xPosition, final int yPosition) {
+            this(id, xPosition, yPosition, 150, 20);
+        }
+
+        public IntegerSliderElement(final int id, final int xPosition, final int yPosition, final int width, final int height) {
+            super(id, xPosition, yPosition, width, height, "");
+
+            this.dragging = false;
+        }
+
+        @Override
+        protected void setDefaultTextures() {
+            this.backgroundTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_background");
+            this.defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider");
+            this.hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_highlighted");
+            this.disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/slider/slider_disabled");
+        }
+
+        private int getSliderWidth() {
+            return 8;
+        }
+
+        @Override
+        public void mouseDragged(final @NotNull Minecraft mc, final int mouseX, final int mouseY) {
+            if (!this.visible) {
+                return;
+            }
+            final int sliderWidth = this.getSliderWidth();
+            final int segments = (this.max - this.min);
+            if (this.dragging && segments != 0) {
+                float percentage = (float) (mouseX - (this.xPosition + 4) - (this.width / (2 * segments))) / (float) (this.width - sliderWidth);
+                if (percentage > 1.0f)
+                    percentage = 1.0f;
+                if (percentage < 0.0f)
+                    percentage = 0.0f;
+                this.sliderValue = this.min + (int) Math.ceil(segments * percentage);
+            }
+            GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+        }
+
+        @Override
+        public void drawButton(final @NotNull Minecraft mc, final int mouseX, final int mouseY) {
+            if (!this.visible) return;
+
+            final boolean mouseOver = mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
+            final int state = this.getButtonState(mouseOver);
+
+            GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+
+            final @NotNull IconCoordinate tex = switch (state) {
+                case STATE_DISABLED -> this.disabledTexture;
+                case STATE_HOVERED -> this.hoveredTexture;
+                default -> this.defaultTexture;
+            };
+
+            // Draw background
+            this.drawGuiIcon(this.xPosition, this.yPosition, this.width, this.height, this.backgroundTexture);
+
+            // Draw foreground
+            final int segments = (this.max - this.min);
+            if (segments != 0) {
+                final int sliderWidth = this.getSliderWidth();
+                this.drawGuiIcon(this.xPosition + (int) (((this.sliderValue - this.min) / (float) segments) * (float) (this.width - sliderWidth)), this.yPosition, sliderWidth, this.height, tex);
+            }
+
+            this.mouseDragged(mc, mouseX, mouseY);
+
+            final int textColor = switch (state) {
+                case 0 -> 0xA0A0A0;
+                case 1 -> 0xE0E0E0;
+                default -> 0xFFFFA0;
+            };
+
+            if (this.renderText) {
+                this.drawStringCenteredShadow(mc.font, this.displayString, this.xPosition + this.width / 2, this.yPosition + (this.height - 8) / 2, textColor);
+            }
+        }
+
+        @Override
+        public boolean mouseClicked(final @NotNull Minecraft mc, final int mouseX, final int mouseY) {
+            if (super.mouseClicked(mc, mouseX, mouseY)) {
+                final int segments = (this.max - this.min);
+                if (segments != 0) {
+                    float percentage = (float) (mouseX - (this.xPosition + 4) - (this.width / (2 * segments))) / (float) (this.width - 8);
+                    if (percentage > 1.0f)
+                        percentage = 1.0f;
+                    if (percentage < 0.0f)
+                        percentage = 0.0f;
+                    this.sliderValue = this.min + (int) Math.ceil(segments * percentage);
+                    this.dragging = true;
+                }
+                return true;
+            } else {
+                return false;
+            }
+        }
+
+        @Override
+        public void mouseReleased(final int mouseX, final int mouseY) {
+            this.dragging = false;
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/ValueNodeComponent.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/ValueNodeComponent.java
new file mode 100644
index 000000000..b879b01ca
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/ValueNodeComponent.java
@@ -0,0 +1,179 @@
+package net.minecraft.client.gui.worldsettings.settingnode;
+
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.paged.ScreenPaged;
+import net.minecraft.client.render.window.CursorShape;
+import net.minecraft.core.lang.text.Text;
+import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.settings.ValueSettingNode;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Objects;
+
+public abstract class ValueNodeComponent<T> extends NestedNodeComponent {
+    private static final int BUTTON_WIDTH = 100;
+    private static final int BUTTON_HEIGHT = 20;
+
+    private final @NotNull Text nameText;
+
+    protected final @NotNull ButtonElement resetButton;
+
+    public ValueNodeComponent(final @NotNull ValueSettingNode<T> valueNode, final int nestLevel) {
+        super(valueNode, nestLevel);
+        this.nameText = valueNode.getName();
+        this.resetButton = new ButtonElement(0, 0, 0, 20, 20, "")
+            .setTextures("minecraft:gui/misc/icon_reset", "minecraft:gui/misc/icon_reset_highlighted", "minecraft:gui/misc/icon_reset");
+    }
+
+    @Override
+    public void reset() {
+        final @Nullable WorldConfiguration worldConfiguration = this.getWorldConfiguration();
+        final @Nullable Dimension dimension = this.getDimension();
+        assert worldConfiguration != null;
+        assert dimension != null;
+
+        worldConfiguration.getDimensionSettings(dimension).setNodeValue(this.getNode(), this.getNode().getDefaultValue(dimension, worldConfiguration));
+        super.reset();
+    }
+
+    @Override
+    public void onUpdate(final @NotNull Dimension dimension, final @NotNull WorldConfiguration worldConfiguration) {
+        super.onUpdate(dimension, worldConfiguration);
+
+        if (!this.getNode().validateValue(this.getValue(), dimension, worldConfiguration)) {
+            worldConfiguration.getDimensionSettings(dimension).withNotificationsSuppressed(dimensionSettings -> {
+                dimensionSettings.setNodeValue(this.getNode(), this.getNode().getDefaultValue(dimension, worldConfiguration));
+            });
+        }
+    }
+
+    public boolean isDefault() {
+        final @Nullable WorldConfiguration worldConfiguration = this.getWorldConfiguration();
+        final @Nullable Dimension dimension = this.getDimension();
+        assert worldConfiguration != null;
+        assert dimension != null;
+
+        final @NotNull T defaultValue = this.getNode().getDefaultValue(dimension, worldConfiguration);
+        final @NotNull T currentValue = this.getValue();
+        return defaultValue == currentValue || defaultValue.equals(currentValue) || currentValue.equals(defaultValue);
+    }
+
+    @Override
+    public int getNestLevelContribution() {
+        return 1;
+    }
+
+    @Override
+    @SuppressWarnings("unchecked")
+    public @NotNull ValueSettingNode<T> getNode() {
+        return (ValueSettingNode<T>) super.getNode();
+    }
+
+    public @NotNull T getValue() {
+        final @Nullable WorldConfiguration worldConfiguration = this.getWorldConfiguration();
+        final @Nullable Dimension dimension = this.getDimension();
+        assert worldConfiguration != null;
+        assert dimension != null;
+
+        final @Nullable T value = worldConfiguration.getDimensionSettings(dimension).getNodeValue(this.getNode(), worldConfiguration);
+        return Objects.requireNonNullElseGet(value, () -> this.getNode().getDefaultValue(dimension, worldConfiguration));
+    }
+
+    @Override
+    public int getBaseHeight() {
+        return super.getBaseHeight() + BUTTON_HEIGHT + COMPONENT_SPACING;
+    }
+
+    @Override
+    public void render(final @NotNull ScreenPaged screen, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        final @NotNull String translated = this.nameText.toString();
+        int textColor = 0xFFFFFFFF;
+        if (relativeMouseX >= 0 && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= this.getHeight() - COMPONENT_SPACING) {
+            textColor = 0xFFFFFFA0;
+        }
+
+        MC.font.render(translated, x, y + (this.getBaseHeight() / 2) - 4).setShadow().setColor(textColor).call();
+        this.resetButton.enabled = !this.isDefault();
+        this.renderResetButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, relativeMouseX, relativeMouseY);
+        this.renderButton(x, y, width - BUTTON_WIDTH, COMPONENT_SPACING, BUTTON_WIDTH, BUTTON_HEIGHT, relativeMouseX, relativeMouseY);
+        final int stringWidth = MC.font.stringWidth(translated);
+        int lineMaxX = x + width - BUTTON_WIDTH - 8;
+        if (this.resetButton.enabled) {
+            lineMaxX -= 20;
+        }
+        this.drawRect(x + stringWidth + 8, y + this.getBaseHeight() / 2, lineMaxX, y + this.getBaseHeight() / 2 + 1, 0x5F7F7F7F);
+
+        super.render(screen, x, y, width, relativeMouseX, relativeMouseY);
+    }
+
+    @Override
+    public boolean onMouseClick(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        if (super.onMouseClick(mouseButton, x, y, width, relativeMouseX, relativeMouseY)) {
+            return true;
+        } else if (relativeMouseX >= width - BUTTON_WIDTH && relativeMouseX <= width && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + BUTTON_HEIGHT) {
+            MC.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+            this.buttonClicked(mouseButton, x, y, width, this.getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+            return true;
+        } else if (this.resetButton.enabled && relativeMouseX >= width - BUTTON_WIDTH - 20 && relativeMouseX <= width - BUTTON_WIDTH && relativeMouseY >= COMPONENT_SPACING && relativeMouseY <= COMPONENT_SPACING + BUTTON_HEIGHT) {
+            MC.sndManager.playSound("random.click", SoundCategory.GUI_SOUNDS, 1.0F, 1.0F);
+            this.reset();
+            return true;
+        }
+
+        return false;
+    }
+
+    @Override
+    public boolean onMouseMove(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        if (!super.onMouseMove(x, y, width, relativeMouseX, relativeMouseY)) {
+            this.buttonDragged(x, y, width, this.getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+        }
+
+        return true;
+    }
+
+    @Override
+    public boolean onMouseRelease(final int mouseButton, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+        if (!super.onMouseRelease(mouseButton, x, y, width, relativeMouseX, relativeMouseY)) {
+            this.buttonReleased(mouseButton, x, y, width, this.getHeight(), relativeMouseX - (width - BUTTON_WIDTH), relativeMouseY - COMPONENT_SPACING);
+        }
+
+        return true;
+    }
+
+    protected abstract boolean buttonClicked(int mouseButton, int x, int y, int width, int height, int relativeMouseX, int relativeMouseY);
+
+    protected void buttonDragged(final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+    }
+
+    protected void buttonReleased(final int mouseButton, final int x, final int y, final int width, final int height, final int relativeMouseX, final int relativeMouseY) {
+    }
+
+    @Override
+    public boolean matchesSearchTerm(final @NotNull String term) {
+        return this.nameText.toString().toLowerCase().contains(term.toLowerCase());
+    }
+
+    private void renderResetButton(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int relativeMouseX, final int relativeMouseY) {
+        if (this.resetButton.enabled) {
+            this.resetButton.xPosition = x + relativeButtonX - BUTTON_HEIGHT;
+            this.resetButton.yPosition = y + relativeButtonY;
+
+            this.resetButton.drawButton(MC, x + relativeMouseX, y + relativeMouseY);
+        }
+    }
+
+    private void renderButton(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY) {
+        this.renderButtonInner(x, y, relativeButtonX, relativeButtonY, buttonWidth, buttonHeight, relativeMouseX, relativeMouseY);
+
+        if (relativeMouseX >= relativeButtonX && relativeMouseX < relativeButtonX + buttonWidth && relativeMouseY >= relativeButtonY && relativeButtonY < relativeButtonY + buttonHeight) {
+            assert MC.currentScreen != null;
+            MC.currentScreen.setDesiredCursor(CursorShape.HAND);
+        }
+    }
+
+    protected abstract void renderButtonInner(final int x, final int y, final int relativeButtonX, final int relativeButtonY, final int buttonWidth, final int buttonHeight, final int relativeMouseX, final int relativeMouseY);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/conversion/NodeAdapterRegistry.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/conversion/NodeAdapterRegistry.java
new file mode 100644
index 000000000..9e14815f2
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/conversion/NodeAdapterRegistry.java
@@ -0,0 +1,52 @@
+package net.minecraft.client.gui.worldsettings.settingnode.conversion;
+
+import it.unimi.dsi.fastutil.objects.Object2ObjectOpenHashMap;
+import net.minecraft.client.gui.worldsettings.settingnode.BooleanValueNodeComponent;
+import net.minecraft.client.gui.worldsettings.settingnode.ListValueNodeComponent;
+import net.minecraft.client.gui.worldsettings.settingnode.NestedNodeComponent;
+import net.minecraft.client.gui.worldsettings.NodeComponent;
+import net.minecraft.client.gui.worldsettings.settingnode.RangeIntegerNodeComponent;
+import net.minecraft.core.world.settings.ContainerSettingNode;
+import net.minecraft.core.world.settings.ListValueSettingNode;
+import net.minecraft.core.world.settings.SettingNode;
+import net.minecraft.core.world.settings.impl.BooleanSettingNode;
+import net.minecraft.core.world.settings.impl.RangeIntegerSettingNode;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Map;
+import java.util.Objects;
+
+public final class NodeAdapterRegistry {
+    private NodeAdapterRegistry() throws IllegalAccessException {
+        throw new IllegalAccessException("No NodeAdapterRegistry for you!");
+    }
+
+    private static final @NotNull Map<@NotNull Class<?>, @NotNull NodeIntoComponentAdapter<?, ?>> ADAPTERS = new Object2ObjectOpenHashMap<>();
+    public static <T extends SettingNode, C extends NodeComponent> void register(final @NotNull Class<T> settingNodeClass, final @NotNull NodeIntoComponentAdapter<T, C> adapter) {
+        ADAPTERS.put(settingNodeClass, adapter);
+    }
+
+    static {
+        register(ContainerSettingNode.class, NestedNodeComponent::new);
+        register(ListValueSettingNode.class, ListValueNodeComponent::new);
+        register(BooleanSettingNode.class, BooleanValueNodeComponent::new);
+        register(RangeIntegerSettingNode.class, RangeIntegerNodeComponent::new);
+    }
+
+    @SuppressWarnings("unchecked")
+    public static <T extends SettingNode, C extends NodeComponent> @NotNull C adapt(final @NotNull T settingNode, final int nestLevel) {
+        final @NotNull Class<T> settingNodeClass = (Class<T>) settingNode.getClass();
+        final @Nullable NodeIntoComponentAdapter<T, C> adapter = (NodeIntoComponentAdapter<T, C>) ADAPTERS.get(settingNodeClass);
+        if (adapter == null) {
+            for (final @NotNull Class<?> clazz : ADAPTERS.keySet()) {
+                if (clazz.isAssignableFrom(settingNodeClass)) {
+                    return (C) ((NodeIntoComponentAdapter<SettingNode, NodeComponent>) Objects.requireNonNull(ADAPTERS.get(clazz))).adapt(settingNode, nestLevel);
+                }
+            }
+            throw new IllegalArgumentException("Node has no adapter!");
+        }
+
+        return adapter.adapt(settingNode, nestLevel);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/conversion/NodeIntoComponentAdapter.java b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/conversion/NodeIntoComponentAdapter.java
new file mode 100644
index 000000000..382757004
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/worldsettings/settingnode/conversion/NodeIntoComponentAdapter.java
@@ -0,0 +1,9 @@
+package net.minecraft.client.gui.worldsettings.settingnode.conversion;
+
+import net.minecraft.client.gui.worldsettings.NodeComponent;
+import net.minecraft.core.world.settings.SettingNode;
+import org.jetbrains.annotations.NotNull;
+
+public interface NodeIntoComponentAdapter<T extends SettingNode, C extends NodeComponent> {
+    @NotNull C adapt(final @NotNull T settingNode, final int nestLevel);
+}
diff --git a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 4e53b667b..42ac2295b 100644
--- a/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
+++ b/game/client/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -61,14 +61,15 @@ import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.RSA;
 import net.minecraft.core.util.helper.UUIDHelper;
-import net.minecraft.core.world.Explosion;
-import net.minecraft.core.world.ExplosionCannonball;
-import net.minecraft.core.world.ICarriable;
-import net.minecraft.core.world.IVehicle;
+import net.minecraft.core.world.*;
 import net.minecraft.core.world.data.SynchedEntityData;
 import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.save.LevelData;
+import net.minecraft.core.world.settings.WorldConfiguration;
+import net.minecraft.core.world.type.WorldType;
+import net.minecraft.core.world.type.WorldTypeGroups;
+import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
@@ -145,7 +146,16 @@ public class PacketHandlerClient extends PacketHandler {
     public void handleLogin(@NotNull PacketLogin packetLogin) {
         this.mc.playerController = new PlayerControllerMP(this.mc, this);
         this.mc.statsCounter.add(StatList.joinMultiplayerStat, 1);
-        this.worldClientMP = new WorldClientMP(this, mc, packetLogin.worldSeed, packetLogin.dimensionId, packetLogin.worldTypeId);
+        final @NotNull WorldConfiguration worldConfiguration = new WorldConfiguration();
+        final @NotNull Dimension dimension = Objects.requireNonNull(Dimension.getDimensionList().get(packetLogin.dimensionId));
+        for (final @NotNull WorldTypeGroups.Group group : WorldTypeGroups.GROUPS) {
+            if (group.get(dimension).equals(Registries.WORLD_TYPES.getItemByNumericId(packetLogin.worldTypeId))) {
+                worldConfiguration.setWorldTypeGroup(group);
+                break;
+            }
+        }
+        worldConfiguration.setNumericSeed(packetLogin.worldSeed);
+        this.worldClientMP = new WorldClientMP(this, mc, worldConfiguration, Dimension.getDimensionList().get(packetLogin.dimensionId));
         this.worldClientMP.isClientSide = true;
         this.mc.changeWorld(this.worldClientMP);
         this.mc.thePlayer.dimension = packetLogin.dimensionId;
@@ -745,7 +755,16 @@ public class PacketHandlerClient extends PacketHandler {
     public void handleRespawn(@NotNull PacketRespawn packetRespawn) {
         if (packetRespawn.respawnDimensionId != this.mc.thePlayer.dimension) {
             this.started = false;
-            this.worldClientMP = new WorldClientMP(this, mc, this.worldClientMP.getLevelData().getRandomSeed(), packetRespawn.respawnDimensionId, packetRespawn.respawnWorldTypeId);
+            final @NotNull WorldConfiguration worldConfiguration = new WorldConfiguration();
+            final @NotNull Dimension dimension = Objects.requireNonNull(Dimension.getDimensionList().get(packetRespawn.respawnDimensionId));
+            for (final @NotNull WorldTypeGroups.Group group : WorldTypeGroups.GROUPS) {
+                if (group.get(dimension).equals(Registries.WORLD_TYPES.getItemByNumericId(packetRespawn.respawnWorldTypeId))) {
+                    worldConfiguration.setWorldTypeGroup(group);
+                    break;
+                }
+            }
+            worldConfiguration.setNumericSeed(this.worldClientMP.getLevelData().getRandomSeed());
+            this.worldClientMP = new WorldClientMP(this, mc, worldConfiguration, Dimension.getDimensionList().get(packetRespawn.respawnDimensionId));
             this.worldClientMP.isClientSide = true;
             this.mc.changeWorld(this.worldClientMP);
             this.mc.thePlayer.dimension = packetRespawn.respawnDimensionId;
diff --git a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index ecae3acf0..4832cf391 100644
--- a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -72,8 +72,8 @@ public class PostProcessingManager {
         if (GameSettings.COLOR_CORRECTION.value == 0) return;
 
         final float y = (float) this.mc.thePlayer.y;
-        final int maxY = this.mc.currentWorld.getWorldType().getMaxY();
-        final int minY = this.mc.currentWorld.getWorldType().getMinY();
+        final int maxY = this.mc.currentWorld.getWorldType().getMaxY(this.mc.currentWorld);
+        final int minY = this.mc.currentWorld.getWorldType().getMinY(this.mc.currentWorld);
         final int rangeY = maxY - minY;
         final int halfY = minY + rangeY / 2;
         final int quarterY = minY + rangeY / 4;
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index d7046525b..30cdf2415 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -309,7 +309,7 @@ public class RenderGlobal
         double cameraZO = camera.getZ(0);
 
         final double scale = 1f;
-        double auroraY = (this.world.getWorldType().getMaxY() + 64f) * 2f;
+        double auroraY = (this.world.getWorldType().getMaxY(this.world) + 64f) * 2f;
 
         // Draw pieces
         double time = this.world.getWorldTime();
@@ -391,7 +391,7 @@ public class RenderGlobal
             mult += temperature;
         }
 
-        double altitude = this.world.getWorldType().getYPercentage((int) cameraY);
+        double altitude = this.world.getWorldType().getYPercentage(this.world, (int) cameraY);
         if ((temperature <= 0.6f || this.world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER || this.world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && altitude >= 0.8f) {
             // altitude from 0.8f to 1.0f
             altitude -= 0.8f;
@@ -891,7 +891,7 @@ public class RenderGlobal
         int k = MathHelper.floor(posZ / 2048D);
         posX -= j * 2048;
         posZ -= k * 2048;
-        float cloudHeight = (worldTypeFX.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
+        float cloudHeight = (worldTypeFX.getCloudHeight(world) - cameraY) + 0.33F + getCloudHeightModifier();
         float f10 = (float) (posX * (double) f6);
         float f11 = (float) (posZ * (double) f6);
         tessellator.startDrawingQuads();
@@ -945,7 +945,7 @@ public class RenderGlobal
         float cloudThickness = 4F;
         double dx = (this.mc.activeCamera.getX(partialTick) + (double) ((this.lastCloudOffsetX + (this.cloudOffsetX - this.lastCloudOffsetX) * partialTick) * 0.03F)) / (double) cloudWidth;
         double dz = (this.mc.activeCamera.getZ(partialTick) + (double) ((this.lastCloudOffsetZ + (this.cloudOffsetZ - this.lastCloudOffsetZ) * partialTick) * 0.03F)) / (double) cloudWidth + 0.33D;
-        float dy = (worldTypeFX.getCloudHeight() - cameraY) + 0.33F + getCloudHeightModifier();
+        float dy = (worldTypeFX.getCloudHeight(world) - cameraY) + 0.33F + getCloudHeightModifier();
         int i = MathHelper.floor(dx / 2048D);
         int j = MathHelper.floor(dz / 2048D);
         dx -= i * 2048;
